#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define int ll

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vector<int> a(n), t(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }

    auto check = [&](int T) {
        ll ans = 0;
        for (int i = 0; i < n && ans < m + 10; ++i) {
            if (T >= a[i] + t[i]) {
                ans += 1LL << min(T - a[i] - t[i] + 1, int(35));
            } else if (T >= a[i]) {
                ans += 1;
            }
        }
        return ans;
    };

    for (int i = 0; i <= 6000; ++i) {
        if (check(i) == m) {
            cout << i << endl;
            return 0;
        }
    }

    int lo = 0, hi = int(2e9) + 100;
    while (lo + 1 < hi) {
        int mid = (hi - lo) / 2 + lo;
        if (check(mid) <= m) {
            lo = mid;
        } else {
            hi = mid;
        }
    }

    if (check(lo) == m) {
        cout << lo << '\n';
        return 0;
    }
    cout << "-1\n";

    return 0;
}
