#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int N = 1e6 + 1;

vector<int> adj[N];
int c[N], mind[N];

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<int> a(n), ans(n);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    for (int p = 2; p < N; ++p) {
        if (mind[p] != 0) {
            continue;
        }
        for (int u = p; u < N; u += p) {
            mind[u] = p;
            adj[u].push_back(u / p);
            adj[u / p].push_back(u);
        }
    }

    auto dfs = [&](auto self, int v) -> void {
        for (int to : adj[v]) {
            if (c[to] == 0) {
                c[to] = 3 - c[v];
                self(self, to);
            }
        }
    };

    for (int i = 1; i < N; ++i) {
        if (c[i] == 0) {
            c[i] = 1;
            dfs(dfs, i);
        }
    }

    for (int i = 0; i < n; ++i) {
        ans[i] = c[a[i]];
        cout << ans[i] << " ";
    }
    cout << '\n';

    return 0;
}
